
import java.awt.Color;
import javax.swing.JFrame;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author samu
 */
public class morseUI extends javax.swing.JFrame {
    static serverTCP serv;

    /**
     * Creates new form morseUI
     */
    public morseUI() {
        initComponents();
        this.getContentPane().setBackground(Color.white);
        this.getRootPane().setDefaultButton(buttonSend);
        textSend.requestFocus();
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    }
    
    public void updateReceivedTextUI(String str, boolean txtClear) {
        
        if (txtClear != false)
            textReceived.setText(null);
        textReceived.append(str);
    }
    
    public void setCommLed(int state) {
        switch (state){
            case 0:
                led1.setBackground(Color.RED);
                break;
            case 1:
                led1.setBackground(Color.GREEN);
                break;
            case 2:
                led1.setBackground(Color.YELLOW);
        }
    }
    
    public void setLPCLed(int state) {
         switch (state){
            case 0:
                led3.setBackground(Color.RED);
                break;
            case 1:
                led3.setBackground(Color.GREEN);
                break;
            case 2:
                led3.setBackground(Color.YELLOW);
        }
    }
    
    public void setControlValues(int freq, int wpm, int volume) {
        jSlider1.setValue(freq);
        jSlider2.setValue(wpm);
        jSlider3.setValue(volume);
    }
    
    public void disableControls() {
        setLPCLed(2);
        jSlider1.setEnabled(false);
        jSlider2.setEnabled(false);
        jSlider3.setEnabled(false);
        buttonSend.setEnabled(false);
        buttonClear.setEnabled(false);
        buttonSet.setEnabled(false);
    }
    
    public void enableControls() {
        setLPCLed(1);
        jSlider1.setEnabled(true);
        jSlider2.setEnabled(true);
        jSlider3.setEnabled(true);
        buttonSend.setEnabled(true);
        buttonClear.setEnabled(true);
        buttonSet.setEnabled(true);
        textSend.requestFocus();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonSend = new javax.swing.JButton();
        textSend = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        textReceived = new javax.swing.JTextArea();
        buttonClear = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        led1 = new javax.swing.JScrollPane();
        jTextPane1 = new javax.swing.JTextPane();
        commStatusLabel = new javax.swing.JLabel();
        lpcStatusLabel = new javax.swing.JLabel();
        led3 = new javax.swing.JScrollPane();
        jTextPane3 = new javax.swing.JTextPane();
        jPanel2 = new javax.swing.JPanel();
        jSlider1 = new javax.swing.JSlider();
        encoderFreqLabel = new javax.swing.JLabel();
        pwmFreqLabel = new javax.swing.JLabel();
        decoderFreq = new javax.swing.JLabel();
        wpmFreqLabel = new javax.swing.JLabel();
        jSlider2 = new javax.swing.JSlider();
        buttonSet = new javax.swing.JButton();
        jSlider3 = new javax.swing.JSlider();
        decoderFreq1 = new javax.swing.JLabel();
        volumeLabel = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("WEMAT user application");
        setBackground(new java.awt.Color(255, 255, 255));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        buttonSend.setText("Convert text to Morse");
        buttonSend.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        buttonSend.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonSendActionPerformed(evt);
            }
        });

        textSend.setToolTipText("");
        textSend.setBorder(javax.swing.BorderFactory.createTitledBorder("Text to encode"));
        textSend.setCursor(new java.awt.Cursor(java.awt.Cursor.TEXT_CURSOR));

        jScrollPane1.setBorder(null);

        textReceived.setEditable(false);
        textReceived.setColumns(20);
        textReceived.setLineWrap(true);
        textReceived.setRows(5);
        textReceived.setBorder(javax.swing.BorderFactory.createTitledBorder("Decoded text"));
        jScrollPane1.setViewportView(textReceived);

        buttonClear.setText("Clear received text");
        buttonClear.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonClearActionPerformed(evt);
            }
        });

        jPanel1.setBackground(new java.awt.Color(255, 255, 255));
        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createTitledBorder(""), "System monitor"));

        led1.setBackground(java.awt.Color.red);
        led1.setViewportView(jTextPane1);

        commStatusLabel.setText("LPC Online");

        lpcStatusLabel.setText("LPC Status");
        lpcStatusLabel.setToolTipText("");

        led3.setBackground(java.awt.Color.red);
        led3.setViewportView(jTextPane3);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(18, 18, 18)
                .addComponent(led1, javax.swing.GroupLayout.PREFERRED_SIZE, 18, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(commStatusLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(led3, javax.swing.GroupLayout.PREFERRED_SIZE, 18, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(lpcStatusLabel)
                .addGap(32, 32, 32))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(led3, javax.swing.GroupLayout.PREFERRED_SIZE, 9, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addComponent(commStatusLabel)
                        .addComponent(led1, javax.swing.GroupLayout.PREFERRED_SIZE, 9, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(lpcStatusLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel2.setBackground(new java.awt.Color(255, 255, 255));
        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createTitledBorder(""), "Morse encoder - decoder options"));

        jSlider1.setMaximum(1200);
        jSlider1.setMinimum(600);
        jSlider1.setToolTipText("");
        jSlider1.setValue(900);
        jSlider1.setOpaque(false);
        jSlider1.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSlider1StateChanged(evt);
            }
        });

        encoderFreqLabel.setText("Encoder freq:");

        pwmFreqLabel.setText("900 Hz");
        pwmFreqLabel.setToolTipText("");
        pwmFreqLabel.setName(""); // NOI18N

        decoderFreq.setText("Speed:");

        wpmFreqLabel.setText("14 wpm");
        wpmFreqLabel.setToolTipText("");
        wpmFreqLabel.setName(""); // NOI18N

        jSlider2.setMaximum(80);
        jSlider2.setMinimum(9);
        jSlider2.setToolTipText("");
        jSlider2.setValue(14);
        jSlider2.setOpaque(false);
        jSlider2.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSlider2StateChanged(evt);
            }
        });

        buttonSet.setText("Set options");
        buttonSet.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonSetActionPerformed(evt);
            }
        });

        jSlider3.setMinimum(1);
        jSlider3.setToolTipText("");
        jSlider3.setOpaque(false);
        jSlider3.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSlider3StateChanged(evt);
            }
        });

        decoderFreq1.setText("Encoder volume");

        volumeLabel.setText("50 %");
        volumeLabel.setToolTipText("");
        volumeLabel.setName(""); // NOI18N

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(buttonSet, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addContainerGap())
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(encoderFreqLabel)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(pwmFreqLabel))
                            .addComponent(jSlider1, javax.swing.GroupLayout.DEFAULT_SIZE, 118, Short.MAX_VALUE))
                        .addGap(52, 52, 52)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(decoderFreq1)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(volumeLabel))
                            .addComponent(jSlider3, javax.swing.GroupLayout.DEFAULT_SIZE, 118, Short.MAX_VALUE))
                        .addGap(46, 46, 46)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(decoderFreq)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(wpmFreqLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                            .addComponent(jSlider2, javax.swing.GroupLayout.DEFAULT_SIZE, 116, Short.MAX_VALUE))
                        .addGap(18, 18, 18))))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(encoderFreqLabel)
                            .addComponent(pwmFreqLabel)
                            .addComponent(decoderFreq)
                            .addComponent(wpmFreqLabel))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jSlider1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jSlider2, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(decoderFreq1)
                            .addComponent(volumeLabel))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jSlider3, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(buttonSet)
                .addGap(7, 7, 7))
        );

        encoderFreqLabel.getAccessibleContext().setAccessibleName("encodeFreqLabel");
        encoderFreqLabel.getAccessibleContext().setAccessibleDescription("");
        pwmFreqLabel.getAccessibleContext().setAccessibleName("pwmFreqLabel");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 486, Short.MAX_VALUE)
                    .addComponent(textSend, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(buttonSend, javax.swing.GroupLayout.PREFERRED_SIZE, 139, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(buttonClear, javax.swing.GroupLayout.PREFERRED_SIZE, 139, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(buttonSend)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(textSend, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(buttonClear)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 193, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        getAccessibleContext().setAccessibleDescription("");

        pack();
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void buttonClearActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonClearActionPerformed
       
        textReceived.setText(null);      
    }//GEN-LAST:event_buttonClearActionPerformed

    private void buttonSendActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonSendActionPerformed
        String txtWifly = textSend.getText().toUpperCase();
        
        if ( (txtWifly.length() > 1) && (!txtWifly.contentEquals(" "))) {
            serv.sendToWifly("*!" + txtWifly);
            textSend.setText(null);
            textSend.setToolTipText("Enviado: " + txtWifly);
            textSend.requestFocus();
            disableControls();
        }
    }//GEN-LAST:event_buttonSendActionPerformed

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        
        //serv.terminateToCloseApp();
        System.exit(0);
    }//GEN-LAST:event_formWindowClosing

    private void jSlider1StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSlider1StateChanged
        String freq = String.valueOf(jSlider1.getValue()) + " Hz";
        
        pwmFreqLabel.setText(freq);
        jSlider1.setToolTipText(freq);
    }//GEN-LAST:event_jSlider1StateChanged

    private void jSlider2StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSlider2StateChanged
        String wpm = String.valueOf(jSlider2.getValue()) + " wpm";
        
        wpmFreqLabel.setText(wpm);
        jSlider2.setToolTipText(wpm);
    }//GEN-LAST:event_jSlider2StateChanged

    private void buttonSetActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonSetActionPerformed
        
        String measures;
        
        measures = "!*" + String.valueOf(jSlider1.getValue()) + 
                "#" + String.valueOf(jSlider2.getValue()) +
                "#" + String.valueOf(jSlider3.getValue());
                
        serv.sendToWifly(measures);
    }//GEN-LAST:event_buttonSetActionPerformed

    private void jSlider3StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSlider3StateChanged
        String volume = String.valueOf(jSlider3.getValue()) + "%";
        
        volumeLabel.setText(volume);
        jSlider2.setToolTipText(volume);
    }//GEN-LAST:event_jSlider3StateChanged

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Window GUI paint refreshing issues */
        System.setProperty("sun.java2d.noddraw", Boolean.TRUE.toString());
        setDefaultLookAndFeelDecorated(true);
        /* Set the look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Windows".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(morseUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(morseUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(morseUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(morseUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        final morseUI gui;
        gui = new morseUI();
        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                gui.setVisible(true);
            }
        });
        
        serv = new serverTCP(gui);
        serv.startTCP();
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton buttonClear;
    private javax.swing.JButton buttonSend;
    private javax.swing.JButton buttonSet;
    private javax.swing.JLabel commStatusLabel;
    private javax.swing.JLabel decoderFreq;
    private javax.swing.JLabel decoderFreq1;
    private javax.swing.JLabel encoderFreqLabel;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSlider jSlider1;
    private javax.swing.JSlider jSlider2;
    private javax.swing.JSlider jSlider3;
    private javax.swing.JTextPane jTextPane1;
    private javax.swing.JTextPane jTextPane3;
    private javax.swing.JScrollPane led1;
    private javax.swing.JScrollPane led3;
    private javax.swing.JLabel lpcStatusLabel;
    private javax.swing.JLabel pwmFreqLabel;
    private javax.swing.JTextArea textReceived;
    private javax.swing.JTextField textSend;
    private javax.swing.JLabel volumeLabel;
    private javax.swing.JLabel wpmFreqLabel;
    // End of variables declaration//GEN-END:variables
}
