/*
 * config.h
 *  Configure system behavior
 *
 *  Created on: 04/11/2013
 *  Author:  Samuel Melero Cuesta
 *  Version: 1.0
 *
 */

#ifndef CONFIG_H_
#define CONFIG_H_

#define DEBUG_SHOW						/* Comment this line to hide debug info  */
#define DEBUG_UART_PORT		( 3UL )		/* DEBUG UART port */
#define DEBUG_UART_BR		( 9600UL )	/* DEBUG UART baudrate */
#define WF_UART_PORT		( 0UL )		/* WIFLY UART port */
#define WF_UART_BAUDRATE	( 9600UL )	/* WIFLY UART port baudrate */
#define LPC_STATUS_OK		"OK"		/* LPC Status info */
#define LPC_STATUS_BUSY		"BS"		/* LPC Status info */


#endif /* CONFIG_H_ */
